/**
 * Lightbox v2.7.1
 * by Lokesh Dhakar - http://lokeshdhakar.com/projects/lightbox2/
 *
 * @license http://creativecommons.org/licenses/by/2.5/
 * - Free for use in both personal and commercial projects
 * - Attribution requires leaving author name, author link, and the license info intact
 */

(function() {
  // Use local alias
  var $ = jQuery;

  var LightboxOptions = (function() {
    function LightboxOptions() {
      this.fadeDuration                = 500;
      this.fitImagesInViewport         = true;
      this.resizeDuration              = 700;
      this.positionFromTop             = 50;
      this.showImageNumberLabel        = true;
      this.alwaysShowNavOnTouchDevices = false;
      this.wrapAround                  = false;
    }

    // Change to localize to non-english language
    LightboxOptions.prototype.albumLabel = function(curImageNum, albumSize) {
      return "Image " + curImageNum + " of " + albumSize;
    };

    return LightboxOptions;
  })();


  var Lightbox = (function() {
    function Lightbox(options) {
      this.options           = options;
      this.album             = [];
      this.currentImageIndex = void 0;
      this.init();
    }

    Lightbox.prototype.init = function() {
      this.enable();
      this.build();
    };

    // Loop through anchors and areamaps looking for either data-lightbox attributes or rel attributes
    // that contain 'lightbox'. When these are clicked, start lightbox.
var photo_id = 0;
var am_photo_plus = 0;
var sr = "http://mydaybook.me/";

      function update_plus (photo_id){
    $.ajax({
            type: 'GET',
            dataType: 'JSON',
            url: '' + sr + 'handler/view_photo_plus.php',
            data: 'photo_id=' + photo_id + '',
            success: function (data) {
                   am_photo_plus = data['amount_plus'];
                   if (data['amount_plus'] == 0) {
                    $(".img_note_plus_block").html("");
                    $(".cnews_amount_modal_open").html("");
                    $(".photo_plus_am").css("display", "none");
                } else {
                    var photo_plus_people = " ";
                    $(".photo_plus_am").css("display", "inline-block");
                    $(".photo_plus_am").html(data["amount_plus"]);
                    for (n in data) {
                        if (data[n]['user_id'] >= 1) {
                            photo_plus_people = '' + photo_plus_people + '<a href="javascript:" class="img_note_plus"><img src="' + data[n]['userpic'] + '"/></a>';
                        }
                    }
                    $(".p_img_note_plus_block").html(photo_plus_people);
                    $(".cnews_amount_modal_open").html(data['count']);
                    $(".cnews_amount_modal_open").attr("id","mm_photo");
                }

                    if (data['amount_plus']  > 0) {
                        $(".p_view_users_block_x").css("display", "block");
                        $(".p_view_users_block_x").css("opacity", "1");
                    } else {
                        $(".p_view_users_block_x").css("display", "none");
                        $(".p_view_users_block_x").css("opacity", "0");
                    }


        }});
      }




      Lightbox.prototype.enable = function() {
      var self = this;
      $('body').on('click', 'a[rel^=lightbox], area[rel^=lightbox], a[data-lightbox], area[data-lightbox]', function(event) {
        var s = $(this).attr("id");
        s = s.split("_");
        photo_id = s[2];
          check_q = 0;



        self.start($(event.currentTarget));
        return false;
      });
    };



    // Build html for the lightbox and the overlay.
    // Attach event handlers to the new DOM elements. click click click
    Lightbox.prototype.build = function() {
      var self = this;
      $("<div id='lightboxOverlay' class='lightboxOverlay'></div><div id='lightbox' class='lightbox'><div class='lb-outerContainer'><div class='lb-container'><img class='lb-image' src='' /><div class='lb-nav'><a class='lb-prev' href='' ></a><a class='lb-next' href='' ></a></div><div class='lb-loader'><a class='lb-cancel'></a></div></div></div><div class='lb-dataContainer'><div class='lb-data'><div class='lb-details'><span class='lb-caption'></span><span class='lb-number'></span></div><div class='lb-closeContainer'><div href='javascript:' class='photo_menu_x'><div class='photo_plus_block'><div class='p_view_users_block_x'><div class='p_view_users_note_plus'><div class='p_view_users_note_plus_form'></div><div class='p_view_users_note_plus_str'></div><div class='p_block_users_plus'><a href='#' class='cnews_amount_modal_open'>12 людям понравилось</a><div class='p_img_note_plus_block'><a href='javascript:' class='p_img_note_plus'><img src=''></a></div></div></div></div><div class='photo_plus_am_block_z'><div class='photo_plus_am_block'><div class='photo_plus_am_block_zzz'><span class='photo_plus_am'>28988</span><a href='javascript:' class='photo_plus_ico' data-icon='&#xe600;'></a></div></div></div></div></div><a class='extra_photo'><span class='extra_photo_t1'></span> <span class='extra_photo_t2' data-icon='&#xe13f;'></span></a><a class='lb-close' data-icon='&#xe154;'></a><div class='photo_extra_menu'><a href='javascript:' class='complain_note_modal_a'>Report</a><a id='open_original_xl' target='_blank' href='javascript:'>Open original</a><span class='photo_extra_menu_str'></spam></div></div></div></div></div>").appendTo($('body'));

      // Cache jQuery objects
      this.$lightbox       = $('#lightbox');
      this.$overlay        = $('#lightboxOverlay');
      this.$outerContainer = this.$lightbox.find('.lb-outerContainer');
      this.$container      = this.$lightbox.find('.lb-container');

      // Store css values for future lookup
      this.containerTopPadding = parseInt(this.$container.css('padding-top'), 10);
      this.containerRightPadding = parseInt(this.$container.css('padding-right'), 10);
      this.containerBottomPadding = parseInt(this.$container.css('padding-bottom'), 10);
      this.containerLeftPadding = parseInt(this.$container.css('padding-left'), 10);


      // Attach event handlers to the newly minted DOM elements
      this.$overlay.hide().on('click', function() {
        self.end();
        return false;
      });

      this.$lightbox.hide().on('click', function(event) {
        if ($(event.target).attr('id') === 'lightbox') {
          self.end();
        }
        return false;
      });

      this.$outerContainer.on('click', function(event) {
        if ($(event.target).attr('id') === 'lightbox') {
          self.end();
        }
        return false;
      });


     this.$lightbox.find('.cnews_amount_modal_open').on('click', function() {
         $("#photo_id_aaa").html(photo_id);
        $("#photo_news_amount_modal_open_a").click();
        return false;
      });
   this.$lightbox.find('.complain_note_modal_a').on('click', function() {
         $("#photo_id_aaa").html(photo_id);
        $("#complain_note_modal_a_v").click();
        return false;
      });

 this.$lightbox.find('#open_original_xl').on('click', function() {

      var src_a = $(".lb-image").attr("src");

       src_c = src_a.split("/");
      src_c = src_c[4];   
      src_b = src_a.split(".");
      src_b = src_b[0];
      src_a = src_a.split("_");
      src_a = src_a[1];



      src_c = ''+src_b+'.mydaybook.me/storage/'+src_c+'/xl_'+src_a+'';
      window.open(src_c, '_blank');
       // return false;
 });

var r = 0;
this.$lightbox.find('.extra_photo').on('click', function() {
    if (r==0){


            $(".p_view_users_block_x").css("display", "none");

      $(".photo_extra_menu").animate({
            "opacity": "0.9"
        }, 100, "swing", function () {
        $(".photo_extra_menu").css("display", "block");
        });

    r = 1;
    }
    else{
        $(".photo_extra_menu").animate({
            "opacity": "0"
        }, 100, "swing", function () {
        $(".photo_extra_menu").css("display", "none");
        });
        r = 0;
    }
});

this.$lightbox.find('.photo_plus_ico').on('mouseleave', function() {
        $(".p_view_users_block_x").delay(800).animate({
            "opacity": "0"
        }, 390, "swing", function () {
            $(".p_view_users_block_x").css("display", "none");
        });
});

this.$lightbox.find('.photo_plus_ico').on('mouseover', function() {
    if (am_photo_plus==0)
    {return false;}
    else {
        $(".photo_extra_menu").css("display", "none");
        $(".p_view_users_block_x").stop(true, true).css("display", "block");
        $(".p_view_users_block_x").stop(true, true).css("opacity", "1");
    }
});

this.$lightbox.find('.p_view_users_block_x').on('mouseleave', function() {
        $(".p_view_users_block_x").delay(800).animate({
            "opacity": "0"
        }, 390, "swing", function () {
            $(".p_view_users_block_x").css("display", "none");
        });
});

this.$lightbox.find('.p_view_users_block_x').on('mouseover', function() {
        $(".p_view_users_block_x").stop(true, true).css("display", "block");
        $(".p_view_users_block_x").stop(true, true).css("opacity", "1");
});


    this.$lightbox.find('.lb-prev').on('click', function() {
        if (self.currentImageIndex === 0) {
          self.changeImage(self.album.length - 1);
        } else {
          self.changeImage(self.currentImageIndex - 1);
        }
        return false;
      });

      this.$lightbox.find('.lb-next').on('click', function() {
        if (self.currentImageIndex === self.album.length - 1) {
          self.changeImage(0);
        } else {
          self.changeImage(self.currentImageIndex + 1);
        }
        return false;
      });

      this.$lightbox.find('.lb-loader, .lb-close').on('click', function() {
        self.end();
        return false;
      });
    };

    // Show overlay and lightbox. If the image is part of a set, add siblings to album array.
      var check_q = 0;
    Lightbox.prototype.start = function($link) {
      var self    = this;
      var $window = $(window);

      $window.on('resize', $.proxy(this.sizeOverlay, this));

      $('select, object, embed').css({
        visibility: "hidden"
      });

      this.sizeOverlay();

      this.album = [];
      var imageNumber = 0;

      function addToAlbum($link) {
        self.album.push({
          link: $link.attr('href'),
          title: $link.attr('data-title') || $link.attr('title')
        });
      }

      // Support both data-lightbox attribute and rel attribute implementations
      var dataLightboxValue = $link.attr('data-lightbox');
      var $links;

      if (dataLightboxValue) {
        $links = $($link.prop("tagName") + '[data-lightbox="' + dataLightboxValue + '"]');
        for (var i = 0; i < $links.length; i = ++i) {
          addToAlbum($($links[i]));
          if ($links[i] === $link[0]) {
            imageNumber = i;
          }
        }
      } else {
        if ($link.attr('rel') === 'lightbox') {
          // If image is not part of a set
          addToAlbum($link);
        } else {
          // If image is part of a set
          $links = $($link.prop("tagName") + '[rel="' + $link.attr('rel') + '"]');
          for (var j = 0; j < $links.length; j = ++j) {
            addToAlbum($($links[j]));
            if ($links[j] === $link[0]) {
              imageNumber = j;
            }
          }
        }
      }

      // Position Lightbox
      var top  = $window.scrollTop() + this.options.positionFromTop;
      var left = $window.scrollLeft();
      this.$lightbox.css({
        top: top + 'px',
        left: left + 'px'
      }).fadeIn(this.options.fadeDuration);

      this.changeImage(imageNumber);
    };

    // Hide most UI elements in preparation for the animated resizing of the lightbox.
    Lightbox.prototype.changeImage = function(imageNumber) {
      var self = this;

      this.disableKeyboardNav();
      var $image = this.$lightbox.find('.lb-image');

      this.$overlay.fadeIn(this.options.fadeDuration);

      $('.lb-loader').fadeIn('slow');
      this.$lightbox.find('.lb-image, .lb-nav, .lb-prev, .lb-next, .lb-dataContainer, .lb-numbers, .lb-caption').hide();

      this.$outerContainer.addClass('animating');

      // When image to show is preloaded, we send the width and height to sizeContainer()
      var preloader = new Image();
      preloader.onload = function() {
        var $preloader, imageHeight, imageWidth, maxImageHeight, maxImageWidth, windowHeight, windowWidth;

var img = new Image();
img.src = self.album[imageNumber].link;
img.onload = function(){
  //$("a:not([href^='http://'])").
  var h = this.width;
  if (h<200)
  {
      $(".extra_photo").css("opacity", "0");
      $(".lb-close").css("opacity", "0");
  }
  else
  {
      $(".extra_photo").css("opacity", "1");
      $(".lb-close").css("opacity", "1");    
  }
}

          if (check_q==0)
          {check_q = 1;
           update_plus(photo_id);

          }

          else if (check_q>0)
          {
        var s = $("ul li a[href^='"+self.album[imageNumber].link+"']");
        var s = s.attr("id");
         s = s.split("_");
        photo_id = s[2];
        update_plus(photo_id);
          }


        $image.attr('src', self.album[imageNumber].link);

        $preloader = $(preloader);

        $image.width(preloader.width);
        $image.height(preloader.height);

        if (self.options.fitImagesInViewport) {
          // Fit image inside the viewport.
          // Take into account the border around the image and an additional 10px gutter on each side.

          windowWidth    = $(window).width();
          windowHeight   = $(window).height();
          maxImageWidth  = windowWidth - self.containerLeftPadding - self.containerRightPadding - 20;
          maxImageHeight = windowHeight - self.containerTopPadding - self.containerBottomPadding - 120;

          // Is there a fitting issue?
          if ((preloader.width > maxImageWidth) || (preloader.height > maxImageHeight)) {
            if ((preloader.width / maxImageWidth) > (preloader.height / maxImageHeight)) {
              imageWidth  = maxImageWidth;
              imageHeight = parseInt(preloader.height / (preloader.width / imageWidth), 10);
              $image.width(imageWidth);
              $image.height(imageHeight);
            } else {
              imageHeight = maxImageHeight;
              imageWidth = parseInt(preloader.width / (preloader.height / imageHeight), 10);
              $image.width(imageWidth);
              $image.height(imageHeight);
            }
          }
        }
        self.sizeContainer($image.width(), $image.height());
      };

      preloader.src          = this.album[imageNumber].link;
      this.currentImageIndex = imageNumber;
    };

    // Stretch overlay to fit the viewport
    Lightbox.prototype.sizeOverlay = function() {
      this.$overlay
        .width($(window).width())
        .height($(document).height());
    };

    // Animate the size of the lightbox to fit the image we are showing
    Lightbox.prototype.sizeContainer = function(imageWidth, imageHeight) {
      var self = this;

      var oldWidth  = this.$outerContainer.outerWidth();
      var oldHeight = this.$outerContainer.outerHeight();
      var newWidth  = imageWidth + this.containerLeftPadding + this.containerRightPadding;
      var newHeight = imageHeight + this.containerTopPadding + this.containerBottomPadding;

      function postResize() {
        self.$lightbox.find('.lb-dataContainer').width(newWidth);
        self.$lightbox.find('.lb-prevLink').height(newHeight);
        self.$lightbox.find('.lb-nextLink').height(newHeight);
        self.showImage();
      }

      if (oldWidth !== newWidth || oldHeight !== newHeight) {
        this.$outerContainer.animate({
          width: newWidth,
          height: newHeight
        }, this.options.resizeDuration, 'swing', function() {
          postResize();
        });
      } else {
        postResize();
      }
    };

    // Display the image and it's details and begin preload neighboring images.
    Lightbox.prototype.showImage = function() {
      this.$lightbox.find('.lb-loader').hide();
      this.$lightbox.find('.lb-image').fadeIn('slow');

      this.updateNav();
      this.updateDetails();
      this.preloadNeighboringImages();
      this.enableKeyboardNav();
    };

    // Display previous and next navigation if appropriate.
    Lightbox.prototype.updateNav = function() {
      // Check to see if the browser supports touch events. If so, we take the conservative approach
      // and assume that mouse hover events are not supported and always show prev/next navigation
      // arrows in image sets.
      var alwaysShowNav = false;
      try {
        document.createEvent("TouchEvent");
        alwaysShowNav = (this.options.alwaysShowNavOnTouchDevices)? true: false;
      } catch (e) {}

      this.$lightbox.find('.lb-nav').show();

      if (this.album.length > 1) {
        if (this.options.wrapAround) {
          if (alwaysShowNav) {
            this.$lightbox.find('.lb-prev, .lb-next').css('opacity', '1');
          }
          this.$lightbox.find('.lb-prev, .lb-next').show();
        } else {
          if (this.currentImageIndex > 0) {
            this.$lightbox.find('.lb-prev').show();
            if (alwaysShowNav) {
              this.$lightbox.find('.lb-prev').css('opacity', '1');
            }
          }
          if (this.currentImageIndex < this.album.length - 1) {
            this.$lightbox.find('.lb-next').show();
            if (alwaysShowNav) {
              this.$lightbox.find('.lb-next').css('opacity', '1');
            }
          }
        }
      }
    };

    // Display caption, image number, and closing button.
    Lightbox.prototype.updateDetails = function() {
      var self = this;

      // Enable anchor clicks in the injected caption html.
      // Thanks Nate Wright for the fix. @https://github.com/NateWr
      if (typeof this.album[this.currentImageIndex].title !== 'undefined' && this.album[this.currentImageIndex].title !== "") {
        this.$lightbox.find('.lb-caption')
          .html(this.album[this.currentImageIndex].title)
          .fadeIn('fast')
          .find('a').on('click', function(event){
            location.href = $(this).attr('href');
          });
      }

      if (this.album.length >= 1 && this.options.showImageNumberLabel) {
        this.$lightbox.find('.lb-number').text(this.options.albumLabel(this.currentImageIndex + 1, this.album.length)).fadeIn('fast');
      } else {
        this.$lightbox.find('.lb-number').hide();
      }

      this.$outerContainer.removeClass('animating');

      this.$lightbox.find('.lb-dataContainer').fadeIn(this.options.resizeDuration, function() {
        return self.sizeOverlay();
      });
    };

    // Preload previous and next images in set.
    Lightbox.prototype.preloadNeighboringImages = function() {
      if (this.album.length > this.currentImageIndex + 1) {
        var preloadNext = new Image();
        preloadNext.src = this.album[this.currentImageIndex + 1].link;
      }
      if (this.currentImageIndex > 0) {
        var preloadPrev = new Image();
        preloadPrev.src = this.album[this.currentImageIndex - 1].link;
      }
    };

    Lightbox.prototype.enableKeyboardNav = function() {
      $(document).on('keyup.keyboard', $.proxy(this.keyboardAction, this));
    };

    Lightbox.prototype.disableKeyboardNav = function() {
      $(document).off('.keyboard');
    };

    Lightbox.prototype.keyboardAction = function(event) {
      var KEYCODE_ESC        = 27;
      var KEYCODE_LEFTARROW  = 37;
      var KEYCODE_RIGHTARROW = 39;

      var keycode = event.keyCode;
      var key     = String.fromCharCode(keycode).toLowerCase();
      if (keycode === KEYCODE_ESC || key.match(/x|o|c/)) {
        this.end();
      } else if (key === 'p' || keycode === KEYCODE_LEFTARROW) {
        if (this.currentImageIndex !== 0) {
          this.changeImage(this.currentImageIndex - 1);
        } else if (this.options.wrapAround && this.album.length > 1) {
          this.changeImage(this.album.length - 1);
        }
      } else if (key === 'n' || keycode === KEYCODE_RIGHTARROW) {
        if (this.currentImageIndex !== this.album.length - 1) {
          this.changeImage(this.currentImageIndex + 1);
        } else if (this.options.wrapAround && this.album.length > 1) {
          this.changeImage(0);
        }
      }
    };

    // Closing time. :-(
    Lightbox.prototype.end = function() {
      this.disableKeyboardNav();
      $(window).off("resize", this.sizeOverlay);
      this.$lightbox.fadeOut(this.options.fadeDuration);
      this.$overlay.fadeOut(this.options.fadeDuration);
      $('select, object, embed').css({
        visibility: "visible"
      });
    };

    return Lightbox;

  })();

  $(function() {
    var options  = new LightboxOptions();
    var lightbox = new Lightbox(options);
  });

}).call(this);






