(function($) {



    $.fn.orgChart = function(options) {
        var opts = $.extend({}, $.fn.orgChart.defaults, options);
        return new OrgChart($(this), opts);        
    }

    $.fn.orgChart.defaults = {
        data: [{id:1, name:'Root', parent: 0}],
        showControls: false,
        allowEdit: false,
        onAddNode: null,
        onDeleteNode: null,
        onClickNode: null,
        newNodeText: '<span style="position: relative; padding-left: 3px; font-size: 10px; top: -2px; font-family: Esqadero;">Добавить связь</span>'
    };

    function OrgChart($container, opts){
        var data = opts.data;
        var nodes = {};
        var rootNodes = [];
        this.opts = opts;
        this.$container = $container;
        var self = this;

        this.draw = function(){
            $container.empty().append(rootNodes[0].render(opts));
            $container.find('.node').click(function(){
                if(self.opts.onClickNode !== null){
                    self.opts.onClickNode(nodes[$(this).attr('node-id')]);
                }
            });

            if(opts.allowEdit){
                $container.find('.node h2').click(function(e){
                    var thisId = $(this).parent().attr('node-id');
                    self.startEdit(thisId);
                    e.stopPropagation();
                });
            }

            // add "add button" listener
            $container.find('.org-add-button').click(function(e){
                var thisId = $(this).parent().attr('node-id');

                if(self.opts.onAddNode !== null){
                    self.opts.onAddNode(nodes[thisId]);
                }
                else{
                    self.newNode(thisId);
                }
                e.stopPropagation();
                //$(".node").zoomTarget();
            });

            $container.find('.org-del-button').click(function(e){
                var thisId = $(this).parent().attr('node-id');

                if(self.opts.onDeleteNode !== null){
                    self.opts.onDeleteNode(nodes[thisId]);
                }
                else{
                    self.deleteNode(thisId);
                }
                e.stopPropagation();
                //$(".node").zoomTarget();
                         var outData = [];
            for(var i in nodes){
                outData.push(nodes[i].data);
            }

                var d = JSON.stringify(outData);
                    $.ajax({
                           type: 'POST',
                           data: 'data=' + d + '',
                           url: 'http://mydaybook.me/org-update.php',
                           success: function (data) {

                    }});




            });
        }
        this.startEdit = function(id){
            var inputElement = $('<div><a class="save_change_xxx">Сохранить</a><input style="padding-top: 0px;padding-bottom: 0px;" placeholder="Имя и фамилия" class="rlut_name"><input style="padding-top: 0px;padding-bottom: 0px;" placeholder="Должность" class="rlut_status"><textarea style="padding-top: 2px;" placeholder="Короткая характеристика" class="rlut_about"></textarea><input style="padding-top: 0px;padding-bottom: 0px;" placeholder="Мобильный номер" class="rlut_mobile_number"><input style="padding-top: 0px;padding-bottom: 0px; font-size: 8px;" placeholder="Ссылка MDB" class="rlut_mdb"><input style="padding-top: 0px;padding-bottom: 0px; font-size: 8px;" placeholder="Ссылка VK" class="rlut_vk"><input style="padding-top: 0px;padding-bottom: 0px; font-size: 8px;" placeholder="Ссылка FB" class="rlut_facebook"><input style="position:absolute; top: -2000px;" class="org-input" type="text" value="'+nodes[id].data.name+'"/></div>');
            $container.find('div[node-id='+id+'] h2').replaceWith(inputElement);

            if ($('<h2>'+nodes[id].data.name+'</h2>').html()!="undefined")
            {
            $container.find('div[node-id='+nodes[id].data.id+'] .rlut_name').val($('<h2>'+nodes[id].data.name+'</h2>').html());
            }
            if ($container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserStatus').html()!="undefined")
            { 
            $container.find('div[node-id='+nodes[id].data.id+'] .rlut_status').val($container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserStatus').html());
            }
            if ($container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserAbout').html()!="undefined")
            {
            $container.find('div[node-id='+nodes[id].data.id+'] .rlut_about').val($container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserAbout').html());
            }
            if ($container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserPhone').html()!="undefined")
            {
            $container.find('div[node-id='+nodes[id].data.id+'] .rlut_mobile_number').val($container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserPhone').html());
            }

        if ($container.find('div[node-id='+nodes[id].data.id+'] .MDB_link').attr("href")!="undefined")
        {
        $container.find('div[node-id='+nodes[id].data.id+'] .rlut_mdb').val($container.find('div[node-id='+nodes[id].data.id+'] .MDB_link').attr("href"));
        }
        if ($container.find('div[node-id='+nodes[id].data.id+'] .VK_link').attr("href")!="undefined")
        {
        $container.find('div[node-id='+nodes[id].data.id+'] .rlut_vk').val($container.find('div[node-id='+nodes[id].data.id+'] .VK_link').attr("href"));
        }
        if ($container.find('div[node-id='+nodes[id].data.id+'] .FB_link').attr("href")!="undefined")
        {
        $container.find('div[node-id='+nodes[id].data.id+'] .rlut_facebook').val($container.find('div[node-id='+nodes[id].data.id+'] .FB_link').attr("href"));
        }


            var commitChange = function(){
                var h2Element = $('<h2>'+nodes[id].data.name+'</h2>');
                  var outData = [];
            for(var i in nodes){
                outData.push(nodes[i].data);
            }

                var d = JSON.stringify(outData);
                    $.ajax({
                           type: 'POST',
                           data: 'data=' + d + '',
                           url: 'http://mydaybook.me/org-update.php',
                           success: function (data) {

                    }});

                if(opts.allowEdit){
                    h2Element.click(function(){
                        self.startEdit(id);
                    })
                }
                inputElement.replaceWith(h2Element);
            }  
            inputElement.focus();
            $(document).on("click", ".save_change_xxx", function () {
                commitChange();
            });

            inputElement.keyup(function(event){
                if(event.which == 13){
                    commitChange();
                }
                else{
                    nodes[id].data.name = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_name').val();
                    nodes[id].data.status = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_status').val();
                    nodes[id].data.about = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_about').val();
                    nodes[id].data.phone = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_mobile_number').val();
                    nodes[id].data.mdb = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_mdb').val();
                    nodes[id].data.vk = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_vk').val();
                    nodes[id].data.fb = $container.find('div[node-id='+nodes[id].data.id+'] .rlut_facebook').val();
                    $container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserPhone').html(nodes[id].data.phone);
                    $container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserStatus').html(nodes[id].data.status);
                    $container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserAbout').html(nodes[id].data.about);
                    $container.find('div[node-id='+nodes[id].data.id+'] .orgChartUserPhone').html(nodes[id].data.phone);
                    $container.find('div[node-id='+nodes[id].data.id+'] .MDB_link').attr("href", nodes[id].data.mdb);
                    $container.find('div[node-id='+nodes[id].data.id+'] .VK_link').attr("href", nodes[id].data.vk);
                    $container.find('div[node-id='+nodes[id].data.id+'] .FB_link').attr("href", nodes[id].data.fb);



                }
            });
            inputElement.blur(function(event){
                commitChange();
            })
        }
    $(document).on("click", "#get_result", function () {
        var outData = [];
            for(var i in nodes){
                outData.push(nodes[i].data);
            }

   console.log(outData);
});
        this.newNode = function(parentId){
            var nextId = Object.keys(nodes).length;
            while(nextId in nodes){
                nextId++;
            }

            self.addNode({id: nextId, name: '', parent: parentId});
        }

        this.addNode = function(data){
            var newNode = new Node(data);
            nodes[data.id] = newNode;
            nodes[data.parent].addChild(newNode);

            self.draw();
            self.startEdit(data.id);
        }

        this.deleteNode = function(id){
            for(var i=0;i<nodes[id].children.length;i++){
                self.deleteNode(nodes[id].children[i].data.id);
            }
            nodes[nodes[id].data.parent].removeChild(id);
            delete nodes[id];
            self.draw();
        }

        this.getData = function(){
            var outData = [];
            for(var i in nodes){
                outData.push(nodes[i].data);
            }
            return outData;
        }

        // constructor
        for(var i in data){
            var node = new Node(data[i]);
            nodes[data[i].id] = node;
        }

        // generate parent child tree
        for(var i in nodes){
            if(nodes[i].data.parent == 0){
                rootNodes.push(nodes[i]);
            }
            else{
                nodes[nodes[i].data.parent].addChild(nodes[i]);
            }
        }

        // draw org chart
        $container.addClass('orgChart');
        self.draw();
    }

    function Node(data){
        this.data = data;
        this.children = [];
        var self = this;

        this.addChild = function(childNode){
            this.children.push(childNode);
        }

        this.removeChild = function(id){
            for(var i=0;i<self.children.length;i++){
                if(self.children[i].data.id == id){
                    self.children.splice(i,1);
                    return;
                }
            }
        }

        this.render = function(opts){
            var childLength = self.children.length,
                mainTable;

            mainTable = "<table cellpadding='0' cellspacing='0' border='0'>";
            var nodeColspan = childLength>0?2*childLength:2;
            mainTable += "<tr><td colspan='"+nodeColspan+"'>"+self.formatNode(opts)+"</td></tr>";

            if(childLength > 0){
                var downLineTable = "<table cellpadding='0' cellspacing='0' border='0'><tr class='lines x'><td class='line left half'></td><td class='line right half'></td></table>";
                mainTable += "<tr class='lines'><td colspan='"+childLength*2+"'>"+downLineTable+'</td></tr>';

                var linesCols = '';
                for(var i=0;i<childLength;i++){
                    if(childLength==1){
                        linesCols += "<td class='line left half'></td>";    // keep vertical lines aligned if there's only 1 child
                    }
                    else if(i==0){
                        linesCols += "<td class='line left'></td>";     // the first cell doesn't have a line in the top
                    }
                    else{
                        linesCols += "<td class='line left top'></td>";
                    }

                    if(childLength==1){
                        linesCols += "<td class='line right half'></td>";
                    }
                    else if(i==childLength-1){
                        linesCols += "<td class='line right'></td>";
                    }
                    else{
                        linesCols += "<td class='line right top'></td>";
                    }
                }
                mainTable += "<tr class='lines v'>"+linesCols+"</tr>";

                mainTable += "<tr>";
                for(var i in self.children){
                    mainTable += "<td colspan='2'>"+self.children[i].render(opts)+"</td>";
                }
                mainTable += "</tr>";
            }
            mainTable += '</table>';
            return mainTable;
        }
        this.formatNode = function(opts){
            var nameString = '',
                descString = '';
           
                if (self.data.name=="")
                {
                    self.data.userpic = "http://s1.mydaybook.me/userpic_empty/userpic_empty_s.png";
                }
            if(typeof data.name !== 'undefined'){
                nameString = '<img class="orgChartUserPhoto" src="'+self.data.userpic+'"><a class="MDB_link" target="_blank" href="'+self.data.mdb+'">Mydaybook</a><a class="VK_link" target="_blank" href="'+self.data.vk+'">Вконтакте</a><a class="FB_link" target="_blank" href="'+self.data.fb+'">Facebook</a><span style="font-size: 10px; top: 25px;" class="orgChartUserStatus">'+self.data.status+'</span><span class="orgChartUserAbout">'+self.data.about+'</span><h2>'+self.data.name+'</h2><span class="orgChartUserPhone" style="font-size: 10px; top: 86px;">'+self.data.phone+'</span><a href="#" id="orgChartUserMDB" style="position: absolute;text-decoration: none;color: #777;right: 5px;top: 27px;font-size: 10px;top: 85px;"></a>';
            }
            if(typeof data.description !== 'undefined'){
                descString = '<p>'+self.data.description+'</p>';
            }
            if(opts.showControls){
                var buttonsHtml = "<div class='org-add-button'>"+opts.newNodeText+"</div><div class='org-del-button'><span style='position: relative; font-size: 6px; top: -4px;'>X</span></div>";
            }
            else{
                buttonsHtml = '';
            }

            return "<div class='node' node-id='"+this.data.id+"'>"+nameString+descString+buttonsHtml+"</div>";
        }
    }

})(jQuery);

